/////////////////////////////////////////////////////////////////////////////////////////////
// copy this folder inside your gamestudio folder
// open inandout.wmp, build it and run it using inandout.wdl
/////////////////////////////////////////////////////////////////////////////////////////////

var video_mode = 7; // 800x600 pixels
var video_depth = 16; // 16 bit mode

var player_coordinates; // global variable, stores the coordinates of the player

/////////////////////////////////////////////////////////////////////////////////////////////

string inandout_wmb = <inandout.wmb>;
string houselevel_wmb = <houselevel.wmb>;

/////////////////////////////////////////////////////////////////////////////////////////////

sound beep_sound = <beep.wav>;

/////////////////////////////////////////////////////////////////////////////////////////////

function main()
{
	level_load (inandout_wmb);
}

action warlock
{
	player = my; 
	while (1) 
	{ 
		my.skill1 = 5 * (key_w - key_s) * time; // 5 = forward / backward movement speed
		my.skill2 = 0;
		my.pan += 5 * (key_a - key_d) * time; // 2 = rotation speed
		vec_set (temp, my.x); 
		temp.z -= 3000; 
		trace_mode = ignore_you + ignore_passable + use_box; 
		my.skill3 = -trace (my.x, temp); 
		move_mode = ignore_passable; 
		ent_move (my.skill1, nullvector); // moves using skill1..3
		if (key_w + key_s > 0) // one of these 2 keys is pressed?
		{
			ent_cycle("walk", my.skill46); // then animate the warlock!
			my.skill46 += 10 * time; // "walk" animation speed 
			my.skill46 %= 100; // loop the animation 
		}
		else // the player isn't moving?
		{
			ent_cycle("stand", 0); // then set the first "stand" animation frame for it
		}
		camera.x = my.x - 50 * cos(my.pan); // place the camera 50 quants
		camera.y = my.y - 50 * sin(my.pan); // behind the player 
		camera.z = my.z + 50; // and higher
		camera.pan = my.pan; // keep the same pan with the player
		camera.tilt = -5; // and look a bit downwards
		wait (1); 
	}
}

action door_level1 // attached to the door in the first level (outdoors)
{
	while (player == null) {wait (1);} // wait until the player is created
	while (vec_dist(player.x, my.x) > 70) {wait (1);} // wait until the player has come closer than 70 quants
	while (key_any == on) {wait (1);} // wait until the player has released the keys
	vec_set (player_coordinates.x, player.x);
	level_load (houselevel_wmb); // load the house level
}

action door_level2 // attached to the door in the second level (indoors)
{
	while (player == null) {wait (1);} // wait until the player is created
	while (vec_dist(player.x, my.x) < 80) {wait (1);} // wait until the player has moved away from the door
	while (vec_dist(player.x, my.x) > 70) {wait (1);} // wait until the player has come closer than 70 quants to the door
	while (key_any == on) {wait (1);} // wait until the player has released the keys
	my = null; // make sure that the lines after level_load are executed
	level_load (inandout_wmb); // load the house level
	wait (3);
	player_coordinates.x -= 50; // make sure that the player appears (50 quants + its initial x) away from the door (hysteresis)
	vec_set (player.x, player_coordinates.x);
	player.pan = 180; // rotate the player in the proper direction (with its back to the door)
}
